CON
  TableSize = 500

VAR
  
  ' Holds the value the output should take at each instant in time.
  long pwm_state[TableSize] 

PUB Start |t

  dira[9] := 1                  ' Make pin 0, pin 1, and pin 2 all outputs
  dira[10] := 1
  dira[16] := 1
  
  SetPWM(9,1)                  
  SetPWM(10,1)                  
  SetPWM(16,1)                 
  


  ' start the time value at zero
  ' PWM Loop
  t := 0
  repeat
    outa := pwm_state[t]        ' Set states of all 3 pwm pins simultaneously
    t += 1                      ' Change to the next state
    if t > TableSize            ' If t goes off the edge of the table
      t := 0                    ' start over at beginning
  

PUB SetPWM(pin, percent) | i, count

  ' Determine how many pixels to turn on for any table size
  count := (percent * TableSize) / 500
  
  repeat i from 0 to TableSize - 1
    if i < count
      pwm_state[i] |= (1 << pin)
    else
      pwm_state[i] &= !(1 << pin)
